<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>[[//TOC//]]</title>
<meta name="generator" content="https://txt2tags.org">
<meta name="viewport" content="width=device-width, initial-scale=1" />
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans&display=swap">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald:400,700">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Montserrat">
<link rel="stylesheet" href="https://www.dicas-l.com.br/css/responsee.css">
<link rel="stylesheet" href="../style/extra.css">
<style>
blockquote{margin: 1em 2em; border-left: 2px solid #999;
  font-style: oblique; padding-left: 1em;}
blockquote:first-letter{margin: .2em .1em .1em 0; font-size: 160%; font-weight: bold;}
blockquote:first-line{font-weight: bold;}
body{font-family: sans-serif;}
hr{background-color:#000;border:0;color:#000;}
hr.heavy{height:2px;}
hr.light{height:1px;}
img{border:0;display:block;}
img.right{margin:0 0 0 auto;}
img.center{border:0;margin:0 auto;}
table{border-collapse: collapse;}
table th,table td{padding: 3px 7px 2px 7px;}
table th{background-color: lightgrey;}
table.center{margin-left:auto; margin-right:auto;}
.center{text-align:center;}
.right{text-align:right;}
.left{text-align:left;}
.tableborder,.tableborder td,.tableborder th{border:1px solid #000;}
.underline{text-decoration:underline;}
</style>
</head>
<body>
<header>
<hgroup>
<h1>[[//TOC//]]</h1>
</hgroup>
</header>


<div class="body">

<section>
<h1>psDoom-NG</h1>

<p>
Mais de 24 anos atrás, em maio de 2000, alguém criou o <a href="http://psdoom.sourceforge.net">psDoom</a>, uma modificação do <strong>Doom</strong> para fechar aplicativos matando monstros durante o jogo 💛. Uma aplicação bastante justificada, se me permitem a opinião. Infelizmente o tempo se encarregou de tornar o <em>patch</em> incompatível com as versões atuais das bibliotecas do sistema operacional.
</p>
<p>
Quatro anos atrás tornou-se possível <a href="http://github.com/storax/kubedoom">remover pods kubernets jogando Doom</a>, no mesmo estilo do <strong>psDoom</strong>. Bateu a saudade e acabei descobrindo que em 2014 uma boa alma revitalizou o código original e o adaptou ao do <a href="http://www.chocolate-doom.org">Chocolate Doom</a>. Agora novamente é possível substituir o clique do <em>mouse</em> “no X” por um satisfatório tiro da sua arma preferida. E não apenas jogando <a href="http://wikipedia.org/wiki/Doom_%281993_video_game%29">Doom</a>, mas <a href="http://wikipedia.org/wiki/Doom_II">Doom 2</a> e pelo menos <a href="http://github.com/freedoom/freedoom">Freedoom Phase 2</a> 👍
</p>
<p>
O projeto chama-se <strong>psDoom-NG</strong> (<em>New Generation</em>) e <a href="http://github.com/keymon/psdoom-ng">está disponível no GitHub</a>.
</p>
<p>
O vídeo a seguir demonstra toda a utilidade e praticidade envolvidas no processo 😎
</p>
<p>
[[play.jpg?400] <a href="http://youtube.com/watch?v=JSpHc945G38">http://youtube.com/watch?v=JSpHc945G38</a>]
</p>

</section>
<section>
<h1>Instalação em Ubuntu</h1>

<section>
<h2>Compilação do código fonte em um //container//</h2>

<p>
Uma boa abordagem para compilar o código fonte é fazê-lo em um <em>container</em>. Isso garante tanto que o procedimento não sofrerá interferência de customizações aplicadas à instalação do <em>host</em>, quanto que não “poluirá” com pacotes de desenvolvimento uma instalação que provavelmente não tem esse objetivo. O uso de um <em>container</em> em detrimento ao de uma VM também traz vantagens, principalmente na simplicidade de integração do resultado da compilação com o <em>host</em>. Além disso, com a mesma facilidade, tem-se acesso não só à mesma versão “limpa” de SO instalado no <em>host</em>, como à qualquer versão de qualquer distribuição, simplificando a possibilidade de uma eventual criação de pacote com o binário resultante.
</p>
<p>
A opção pelo uso do <a href="https://podman.io"><code>podman</code></a> em vez do popular <a href="https://docker.io"><code>docker</code></a> é devida a algumas características interessantes do <code>podman</code> para o uso proposto acima. Em especial, ele é executado sem a necessidade de um <em>daemon</em> e de privilégios de <em>root</em> o que o torna mais leve e mais seguro. Também, por ser executado como usuário, um diretório do <em>host</em> compartilhado como volume para o <em>container</em> terá seu conteúdo gravado pelo root do <em>container</em> automaticamente pertencente ao usuário que o executou, o que torna transparente o intercâmbio entre o que é feito do lado do <em>host</em> e do que é feito do lado do <em>container</em>.
</p>
<p>
Instalação do <code>podman</code> e execução do <em>container</em>:
</p>

<pre class="comandos">
<span class="saida">sudo apt install -y podman</span>
<span class="saida">sudo usermod --add-subuids 100000-165535 --add-subgids 100000-165535 $USER</span>
<span class="saida">cat /etc/sub?id</span>
<span class="saida">podman system migrate</span>
<span class="saida">ls -la ~/.local/share/containers</span>

<span class="saida">dir=dica</span>
<span class="saida">mkdir -p $dir</span>
<span class="saida">cd $dir</span>

<span class="saida">args=(</span>
<span class="saida">  --rm</span>
<span class="saida">  --tty</span>
<span class="saida">  --interactive</span>
<span class="saida">  --volume   $PWD:/$dir</span>
<span class="saida">  --workdir /$dir</span>
<span class="saida">  --hostname $dir</span>
<span class="saida">  --name     $dir</span>
<span class="saida">)</span>

<span class="saida">. /etc/os-release</span>

<span class="saida">podman run "${args[@]}" ubuntu:$VERSION_ID bash</span>
</pre>

</section>
<section>
<h2>Compilação do código fonte</h2>

<p>
Seja em <em>container</em>, seja no próprio <em>host</em>, o procedimento descrito a partir desse ponto é basicamente o mesmo.
</p>

<hr class="light">

<p>
Como o processo de download e compilação do código fonte muito provavelmente exigirá a instalação de alguns pacotes, vamos preparar o <code>apt</code> para agir não interativamente usando seus <em>defaults</em> e sincronizar suas listagens locais de pacotes com as dos repositórios instalados. Também popularemos a variável <code>$sudo</code> com a <em>string</em> <code>sudo</code> caso o comando esteja instalado e o usuário ativo não seja <em>root</em>. Se o comando <code>sudo</code> não estiver instalado possivelmente estaremos trabalhando em um <em>container</em>. Se o usuário for <em>root</em>, o comando <code>sudo</code> é desnecessário. Em qualquer uma dessas duas situações, a variável será mantida vazia e dessa forma podemos copiar e colar as linhas inteiras abaixo, sem preocupação em incluir ou excluir a palavra <strong>sudo</strong> no processo.
</p>

<pre class="comandos">
<span class="saida">{ hash sudo 2&gt;&amp;amp;- &amp;amp;&amp;amp; ((UID&gt;0)); } &amp;amp;&amp;amp; sudo=sudo || sudo=</span>
<span class="saida">export DEBIAN_FRONTEND=noninteractive</span>
$sudo apt update
</pre>

<p>
Baixamos o código fonte. A forma tradicional de fazer isso para projetos versionados com <code>git</code> é clonando o repositório.
</p>

<pre class="comandos">
$sudo apt install -y git
<span class="saida">git clone http://github.com/keymon/psdoom-ng</span>
<span class="saida">cd psdoom-ng/trunk</span>
</pre>

<p>
Para compilar o código é necessário um conjunto mínimo de pacotes voltados a esse objetivo. O meta-pacote <code>build-essential</code> instala esses pacotes.
</p>

<pre class="comandos">
$sudo apt install -y build-essential
</pre>

<p>
Configuramos o código para compilação.
</p>

<pre class="comandos">
<span class="saida">time ./configure</span>
</pre>

<p>
Eventualmente ainda podem faltar comandos ou bibliotecas. O comando <code>apt-file</code> permite identificar o nome dos pacotes que possuem um arquivo, dado seu caminho ou nome. A escolha do pacote correto dentre os listados é de responsabilidade do usuário 🙂.
</p>

<pre class="comandos">
$sudo apt install -y apt-file
$sudo apt-file update
<span class="saida">apt-file search -x sdl-config$</span>
<span class="saida">apt-file search -x SDL_mixer.h$</span>
<span class="saida">apt-file search -x SDL_net.h$</span>

$sudo apt install -y automake1.11 libsdl{,-mixer,-net}1.2-dev

<span class="saida">time ./configure</span>
</pre>

<p>
Finalmente compilamos.
</p>

<pre class="comandos">
<span class="saida">time make</span>
</pre>

<p>
Do Ubuntu pelo menos 18.04 até o 23.04, o <code>gcc</code> permite uma compilação fluída:
</p>

<pre class="comandos">
<span class="saida">gcc --version | head -n1</span>
<span class="saida"># gcc (Ubuntu 7.5.0-3ubuntu1~18.04) 7.5.0</span>
<span class="saida"># gcc (Ubuntu 12.3.0-1ubuntu1~23.04) 12.3.0</span>
</pre>

<p>
A partir do Ubuntu 23.10 (<code>gcc</code> 13.2.0) nos deparamos com o erro:
</p>

<pre class="comandos">
<span class="saida">gcc -DHAVE_CONFIG_H -I. -I.. -I../opl -I../textscreen -I../pcsound -O2 -g -Wall -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT -MT i_sdlsound.o -MD -MP -MF .deps/i_sdlsound.Tpo -c -o i_sdlsound.o i_sdlsound.c</span>
<span class="saida">i_sdlsound.c: In function 'I_PrecacheSounds_SRC':</span>
<span class="saida">i_sdlsound.c:514:44: error: assignment of read-only location '*(src_data.data_in + (sizetype)((long unsigned int)sample_i * 4))'</span>
<span class="saida">  514 |                 src_data.data_in[sample_i] = data[sample_i] / 127.5 - 1;</span>
<span class="saida">      |                                            ^</span>
</pre>

<p>
Consultando <a href="http://google.com/search?q=i_sdlsound.c+fix+compilation">O Oráculo</a>, chegamos à uma <a href="http://github.com/chocolate-doom/chocolate-doom/issues/788">issue no **Chocolate Doom** de 2016</a>, curiosamente fazendo referência a um erro muito parecido. Apesar de não ser exatamente o mesmo erro , a <a href="http://github.com/chocolate-doom/chocolate-doom/commit/15b8e6e1e47e4f733f862c16a5c18a3485bd22d4">solução adotada</a> serve perfeitamente para criar um patch aplicável ao caso de um Ubuntu &gt;= 23.10.
</p>
<p>
Para criar o <em>patch</em>, começamos fazendo duas cópias do arquivo original: uma apenas para podermos voltar atrás se tudo der errado (<code>i_sdlsound.c-ori</code>) e outra onde faremos manualmente as alterações necessárias (<code>i_sdlsound.c-new</code>). No fim, comparamos o inicial (<code>i_sdlsound.c</code>) com o novo usando o comando <code>diff</code>.
</p>

<pre class="comandos">
<span class="saida">cd src</span>
<span class="saida">cp -a i_sdlsound.c i_sdlsound.c-ori</span>
<span class="saida">cp -a i_sdlsound.c i_sdlsound.c-new</span>
<span class="saida">vi i_sdlsound.c-new # alterações manuais</span>
<span class="saida">diff -Naru i_sdlsound.c{,-new} &gt; i_sdlsound.c.patch</span>
<span class="saida">cat i_sdlsound.c.patch</span>
</pre>

<p>
O conteúdo do <em>patch</em> será algo como:
</p>

<pre class="comandos">
<span class="saida">--- i_sdlsound.c        2024-06-24 03:25:45.638761441 +0000</span>
<span class="saida">+++ i_sdlsound.c-new    2024-06-24 03:15:52.917510437 +0000</span>

<span class="saida">@@ -486,13 +486,15 @@</span>
<span class="saida">             float *rsound;</span>
<span class="saida">             uint32_t rlen;</span>
<span class="saida">            SRC_DATA src_data;</span>
<span class="saida">+           float *data_in;</span>

<span class="saida">            if (!LoadSoundLump(sound_i, &amp;amp;lumpnum, &amp;amp;samplerate, &amp;amp;length, &amp;amp;data))</span>
<span class="saida">                continue;</span>

<span class="saida">             assert(length &lt;= LONG_MAX);</span>
<span class="saida">            src_data.input_frames = length;</span>
<span class="saida">-           src_data.data_in = malloc(length * sizeof(float));</span>
<span class="saida">+           data_in = malloc(length * sizeof(float));</span>
<span class="saida">+           src_data.data_in = data_in;</span>
<span class="saida">            src_data.src_ratio = (double)mixer_freq / samplerate;</span>

<span class="saida">            // mixer_freq / 4 adds a quarter-second safety margin.</span>

<span class="saida">@@ -511,7 +513,7 @@</span>
<span class="saida">                // whether a symmetrical range should be assumed.  The</span>
<span class="saida">                // following assumes a symmetrical range.</span>

<span class="saida">-               src_data.data_in[sample_i] = data[sample_i] / 127.5 - 1;</span>
<span class="saida">+               data_in[sample_i] = data[sample_i] / 127.5 - 1;</span>
<span class="saida">            }</span>

<span class="saida">             // don't need the original lump any more</span>

<span class="saida">@@ -525,7 +527,7 @@</span>
<span class="saida">             assert(src_data.output_frames_gen &gt; 0);</span>
<span class="saida">             resampled_sound[sound_i] = src_data.data_out;</span>
<span class="saida">             resampled_sound_length[sound_i] = src_data.output_frames_gen;</span>
<span class="saida">-            free(src_data.data_in);</span>
<span class="saida">+            free(data_in);</span>
<span class="saida">             good_sound[sound_i] = true;</span>

<span class="saida">             // Track maximum amplitude for later normalization</span>
</pre>

<p>
Idealmente, o conteúdo do <em>patch</em> deve ser absolutamente idêntico à saída do comando <code>diff</code>, por isso ele costuma ser redirecionado para um arquivo ao invés de enviado para a tela para ser copiado e colado no arquivo do <em>patch</em>. Quando o conteúdo é copiado e colado, eventuais caracteres <code>tab</code> presentes nas linhas serão trocados por espaços e o comando <code>patch</code> não reconhecerá as linhas que deveriam ser alteradas. Existem opções no comando <code>patch</code> para driblar essas situações, mas o melhor é tentar evitá-las. Para não ser necessário copiar e colar em um arquivo o <em>patch</em> mostrado acima, ele está disponível para download <a href="https://gitlab.com/arkanon/misc/dicas-l/-/raw/master/dicas/3_em_1-compilando_em_container_criando_patches_e_matando_com_escopeta/i_sdlsound.c.patch">nesse endereço</a>. Basta salvar o arquivo no diretório do clone do repositório do psDoom-NG e aplicar o comando <code>patch</code> indicando na opção <code>-p</code> quantos níveis de diretório devem ser ignorados na identificação dos arquivos que serão alterados. Adicionalmente, a opção <code>--dry-run</code> permite que o comando <code>patch</code> apenas mostre o resultado do que seria executado, permitindo analisar se as opções usadas foram adequadas e suficientes, ou não.
</p>

<pre class="comandos">
<span class="saida">cd src</span>
$sudo apt install -y wget
<span class="saida">wget -c gitlab.com/arkanon/misc/dicas-l/-/raw/master/dicas/3_em_1-compilando_em_container_criando_patches_e_matando_com_escopeta/i_sdlsound.c.patch</span>
<span class="saida">patch -p0 --dry-run &lt; i_sdlsound.c.patch</span>
<span class="saida"># checking file i_sdlsound.c</span>
</pre>

<p>
Se o comando acima não indicou nenhum erro, ou pelo menos indicou erros aceitáveis:
</p>

<pre class="comandos">
<span class="saida">patch -p0 &lt; i_sdlsound.c.patch</span>
<span class="saida"># patching file i_sdlsound.c</span>
</pre>

<p>
Então, se a primeira tentativa de compilação falhou apenas devido ao erro que o <em>patch</em> corrige, agora ela deve chegar ao fim sem tropeços:
</p>

<pre class="comandos">
<span class="saida">cd ..</span>
<span class="saida">time make</span>
</pre>

<p>
Não sei vocês, mas eu sou um mero usuário 😢. Não saberia o que fazer com as informações de <em>debug</em> mantidas em um código compilado. Por isso, vou mandá-las para o (<em>cyber</em>)espaço. Uma vantagenzinha obtida com isso é a possivelmente drástica redução do tamanho dos executáveis.
</p>

<pre class="comandos">
$sudo apt install -y file
<span class="saida">lsb=$(find . -type f -exec file {} \; | grep -E 'LSB shared|LSB pie')</span>
<span class="saida">grep --color -E '[^/:]+:' &lt;&lt;&lt; $lsb</span>
<span class="saida">exec=$(cut -d: -f1 &lt;&lt;&lt; $lsb)</span>
<span class="saida">ls -la $exec</span>
<span class="saida">du -ch $exec</span>
<span class="saida">strip  $exec</span>
</pre>

<p>
Aqui podemos deixar de agir no <em>container</em>, se até agora estávamos. Se o código fonte foi compilado em uma distro-versão compatível com o <em>host</em>, os próximos passos podem ser executados nela.
</p>
<p>
Agora o código compilado pode ser instalado. Ou esse passo pode ser ignorado, se estivermos apenas curiosos e sem planos de manter o binário. Podemos simplesmente executar o <strong>psDoom</strong> diretamente do diretório em que foi compilado.
</p>

<pre class="comandos">
<span class="saida">make install</span>
</pre>

</section>
</section>
<section>
<h1>Configuração</h1>

<p>
Os parâmetros do aplicativo <code>src/psdoom</code> estão documentados no arquivo <code>CMDLINE</code>
</p>

<pre class="comandos">
<span class="saida">cat CMDLINE</span>
</pre>

<p>
Os arquivos <em>default</em> de configuração ficarão em <code>~/.psdoom</code>
</p>
<p>
O aplicativo <code>setup/psd-setup</code> pode ser usado para configurar algumas características do <strong>psDoom</strong>.
 Algumas podem ser configuradas pela interface do próprio <strong>psDoom</strong>, outras, apenas pelo <code>psd-setup</code> mesmo.
</p>
<p>
Configurando o <strong>psDoom</strong> pelo <code>psd-setup</code>, alguns parâmetros são armazenados no arquivo <code>default.cfg</code>, outros no arquivo <code>psd-doom.cfg</code>. Não sei se é um bug ou uma característica, mas o jogo em si, usa o aquivo <code>psdoom.cfg</code>, e não <code>psd-doom.cfg</code>. Então, para poder usar o <code>psd-setup</code> e não ter que copiar ou mover o arquivo <code>psd-doom.cfg</code> para <code>psdoom.cfg</code>, podemos resolver essa inconsistência com um <em>link</em> simbólico.
</p>

<pre class="comandos">
<span class="saida">./setup/psd-setup</span>

<span class="saida">ln -fs psd-doom.cfg $HOME/.psdoom/psdoom.cfg</span>
<span class="saida">ls -la $HOME/.psdoom</span>
</pre>

<p>
Também podemos identificar os parâmetros que nos interessam e criar os arquivos de configuração já com eles no valor desejado, deixando de lado o <code>psd-setup</code>. Os comentários acabarão removidos quando os outros parâmetros forem adicionados pelo <strong>psDoom</strong>.
</p>

<pre class="comandos">
<span class="saida">mkdir -p $HOME/.psdoom</span>
<span class="saida">ln -fs psd-doom.cfg $HOME/.psdoom/psdoom.cfg</span>

<span class="saida">cat &lt;&lt; EOT &gt;| $HOME/.psdoom/psd-doom.cfg</span>
<span class="saida">  fullscreen      0    # Display  &gt; Full screen  OFF</span>
<span class="saida">  screen_width    1024 # Display  &gt; Window size  WIDTH</span>
<span class="saida">  screen_height   800  # Display  &gt; Window size  HEIGHT</span>
<span class="saida">  show_endoom     0    # Display  &gt; Advanced &gt; Show ENDOOM screen on exit  OFF</span>
<span class="saida">  novert          1    # Mouse    &gt; Allow vertical mouse movement  OFF</span>
<span class="saida">  grabmouse       1    # Mouse    &gt; Grab mouse in windowed mode    OFF</span>
<span class="saida">  dclick_use      0    # Mouse    &gt; Double click acts as "use"     OFF</span>
<span class="saida">  mouseb_use      1    # Mouse    &gt; More buttons... &gt; Use          RIGHT</span>
<span class="saida">EOT</span>

<span class="saida">cat &lt;&lt; EOT &gt;| $HOME/.psdoom/default.cfg</span>
<span class="saida"># joyb_speed      0    # Keyboard &gt; Always run      OFF</span>
<span class="saida">  joyb_speed      29   # Keyboard &gt; Always run      ON</span>
<span class="saida">  mouseb_forward  -1   # Mouse    &gt; Move forward    NONE</span>
<span class="saida">  mouseb_strafe   2    # Mouse    &gt; Strafe on       MIDLE</span>
<span class="saida">  mouseb_fire     0    # Mouse    &gt; Fire weapon     LEFT</span>
<span class="saida">  sfx_volume      3    # Sound    &gt; SFX volume      3</span>
<span class="saida">  snd_musicdevice 8    # Sound    &gt; Music playback  Native MIDI</span>
<span class="saida"># snd_musicdevice 3    # Sound    &gt; Music playback  OPL (Adlib/SB)</span>
<span class="saida">  music_volume    1    # Sound    &gt; Music volume    1</span>
<span class="saida">  screenblocks    11   # tamanho da tela</span>
<span class="saida">EOT</span>
</pre>

</section>
<section>
<h1>Execução</h1>

<p>
Parece que o <strong>psDoom</strong> utiliza apenas os níveis <a href="http://doom.fandom.com/wiki/E1M1">E1M1 Hangar</a> no <strong>Doom 1</strong> e <a href="http://doom.fandom.com/wiki/MAP01">MAP01 Entryway</a> no <strong>Doom 2</strong> para associar aos processos.
 Além disso, por <em>default</em>, associa a monstros <strong>todos</strong> os processos disponíveis. É um comportamento um tanto “perigoso”, encarado apenas pelos que não têm medo de morrer 😛
 Como sou franguinho, executarei apenas alguns aplicativos específicos e indicarei ao <strong>psDoom</strong> uma alternativa ao comando <code>ps</code>, de forma que ele veja apenas os aplicativos “matáveis”.
</p>
<p>
Assim, vamos lançar 12 instâncias do <code>xclock</code> e do <code>xeye</code> distribuídos em quantidades aleatórias, configurar o <strong>psDoom</strong> para “ver” apenas esses processos, e heróicamente fechá-los a tiros de escopeta 😏
 São programinhas normalmente instalados por <em>default</em>. Se não estiverem, pertencem ao pacote <code>x11-apps</code>.
</p>

<pre class="comandos">
<span class="saida">sudo apt install x11-apps</span>
<span class="saida">apps=(xclock xeyes) # c1</span>

<span class="saida">s=40; for i in {0..12}; { ${apps[((RANDOM%2))]} -geometry 100x100+$((s+(s+100)*i))+$((s+24)) &amp;amp; disown $!; } &amp;amp;&gt; /dev/null # c2</span>
</pre>

<p>
Para atrelar processos a monstros, o <strong>psDoom</strong> usa linhas de dados no formato <code>USER PID CMD DEMON</code> onde <code>DEMON</code> é um dígito booleano indicando se o processo será associado ao <a href="http://doom.fandom.com/wiki/Shotgun_Guy">ShotGun Guy</a> (0) ou ao <a href="http://doom.fandom.com/wiki/Demon">Demon</a> (1).
 Vamos usar um comando que substitua a saída padrão do <code>ps</code>. Vai mostrar no formato acima apenas os processos dos aplicativos desejados associando-os ao <em>ShotGun Guy</em> (<em>boolean</em> 0). Também vai incluir o processo do próprio <strong>psDooom</strong>, associado-o ao <em>Demon</em> (<em>boolen</em> 1) só pra ver o que acontece quando este for morto… 😉
</p>
<p>
Abreviamos o <code>ps</code>, armazenando em uma variável o que for comum a todas as chamadas do comando.
</p>

<pre class="comandos">
<span class="saida">ps="ps ho user,pid,comm -C" # c3</span>
</pre>

<p>
Processamos a saída do comando <code>ps</code> relativa aos aplicativos escolhidos e ao <strong>psDoom</strong>.
</p>

<pre class="comandos">
<span class="saida">for i in ${apps[*]}; { $ps $i | sed -r 's/$/ 0/'; }; $ps psdoom | sed -r 's/$/ 1/' # c4</span>
</pre>

<p>
Utilizamos o modelo acima para indicar ao <strong>psDoom</strong> que <strong>esse</strong> é o comando <code>ps</code> que deve ser utilizado.
</p>

<pre class="comandos">
<span class="saida">export PSDOOMPSCMD="for i in ${apps[*]}; { $ps \$i | sed -r 's/$/ 0/'; }; $ps psdoom | sed -r 's/$/ 1/'" # c5</span>
</pre>

<p>
Na execução do <code>ps</code> para buscar os processos e associá-los aos monstros é usada uma chamada ao <code>sh</code>. Como normalmente <code>/bin/sh</code> é um <em>link</em> apontando para algum <em>shell</em> propriamente dito, e esse <em>shell</em> possivelmnete é mais simplificado (como o <code>dash</code> no Ubuntu), uma forma de usar o <code>bash</code> sem modificar o código fonte é refazendo o <em>link</em> <code>sh</code>.
</p>

<pre class="comandos">
<span class="saida">sudo ln -fs bash /bin/sh</span>
</pre>

<p>
Indicamos também um diretório <em>default</em> onde serão procurados os arquivos <code>wad</code> (dessa forma não será necessário apontar o caminho na chamado do jogo)
</p>

<pre class="comandos">
<span class="saida">mkdir -p wad</span>
<span class="saida">cd wad</span>

<span class="saida">wget -qO- doomworld.com/3ddownloads/ports/shareware_doom_iwad.zip | zcat &gt; doom.wad</span>

<span class="saida">wget -q   github.com/freedoom/freedoom/releases/download/v0.13.0/freedoom-0.13.0.zip</span>
<span class="saida">unzip -j freedoom-0.13.0.zip freedoom-0.13.0/freedoom2.wad</span>
<span class="saida">rm freedoom-0.13.0.zip</span>

<span class="saida">export DOOMWADPATH=$PWD # c6</span>
</pre>

<p>
<a href="http://doom.fandom.com/wiki/Shareware">**Doom 2** Não teve versão shareware</a> então, para usar seu <code>IWAD</code>, é preciso uma cópia comercial do jogo.
</p>
<p>
E pronto. Executamos o <strong>psDoom</strong> indicando um <code>IWAD</code> 🎉
</p>

<pre class="comandos">
<span class="saida">src/psdoom -iwad doom.wad -warp 1 # c7</span>
</pre>

</section>
<section>
<h1>Solução de problemas</h1>

<p>
<strong>Mensagem na execução relacionada ao <code>fluidsynth</code></strong> tentar sem sucesso promover sua prioridade de <em>thread</em> e bloquear o <em>soundfont</em> que está usando na memória não trocável (<em>non-swappable memory</em>) para melhorar o desempenho.
</p>

<pre class="comandos">
<span class="saida">fluidsynth: warning: Failed to pin the sample data to RAM; swapping is possible.</span>
</pre>

<p>
Temos duas causas possíveis: falta de recursos para o grupo <code>audio</code> <strong>ou</strong> (inclusivo) falta de acesso do usuário a esses recursos devido ao fato de não pertencer ao grupo <code>audio</code>.
 Sendo apenas um <em>warning</em>, não há maiores consequências, mas desejando resolver, duas ações podem ser necessárias.
</p>

 <ol>
 <li>destinar os recursos necessários ao grupo <code>audio</code> aumentando os limites <em>default</em>.
  Editamos como <code>root</code> o arquivo <code>/etc/security/limits.conf</code> e incluímos as linhas
 <p></p>

<pre class="comandos">
<span class="saida">@audio - rtprio  90</span>
<span class="saida">@audio - memlock unlimited</span>
</pre>

 <p></p>
 </li>
 <li>incluir o usuário no grupo <code>audio</code>:
 <p></p>

<pre class="comandos">
<span class="saida">sudo usermod -aG audio $USER</span>
</pre>

 <p></p>
Tanto o aumento de recurso quanto a inclusão no grupo não serão visíveis pelo ambiente atual, mesmo reabrindo o terminal.
 <p></p>

<pre class="comandos">
<span class="saida">id | grep --color audio</span>
</pre>

 <p></p>
Tradicionalmente, o próximo passo seria o doloroso processo de <em>logout///</em>login//. Mesmo o comando <code>newgrp</code> não será suficiente nesse caso. Mas ainda podemos evitar a reentrada na sessão gráfica fazendo um simples <code>ssh</code> na máquina local garantindo que o <code>X11Forwarding</code> seja utilizado.
 <p></p>

<pre class="comandos">
<span class="saida">ssh -X localhost</span>
</pre>

 <p></p>
Isso exige que o pacote do <code>sshd</code> esteja instalado e que ele esteja configurado para aceitar <code>X11Forwarding</code>.
 <p></p>

<pre class="comandos">
<span class="saida">sudo apt install openssh-server</span>
<span class="saida">grep X11Forwarding /etc/ssh/sshd_config</span>
</pre>

 <p></p>
O comando <code>grep</code> acima deve retornar a linha <code>X11Forwarding yes</code> não comentada com #. Se não retornar nada, ou retornar comentada ou descomentada mas com <em>no</em> ao invés de <em>yes</em>, edite como <code>root</code> o arquivo <code>/etc/ssh/sshd_config</code> e ajuste nesse sentido. Depois reinicie o servidor <code>ssh</code>.
 <p></p>

<pre class="comandos">
<span class="saida">sudo systemctl restart sshd</span>
</pre>

 <p></p>
<strong>Mensagens na execução relacionadas ao <code>fluidsynth</code></strong> não encontrar o <em>soundfont</em> <code>TimGM6mb.sf2</code>
 <p></p>

<pre class="comandos">
<span class="saida">fluidsynth: error: Unable to open file "/usr/share/sounds/sf2/TimGM6mb.sf2"</span>
<span class="saida">fluidsynth: error: Couldn't load soundfont file</span>
<span class="saida">fluidsynth: error: Failed to load SoundFont "/usr/share/sounds/sf2/TimGM6mb.sf2"</span>
</pre>

 <p></p>
Apesar de ser um <em>erro</em> e não apenas um <em>warning</em>, também não apresenta maiores consequências, uma vez que tanto a trilha quanto os efeitos sonoros soam (literalmente) normais, pelo menos com o dispositivo de áudio <code>Native MIDI</code> configurado no arquivo <code>default.cfg</code>. Para resolver, basta instalar o pacote <code>timgm6mb-soundfont</code>:
 <p></p>

<pre class="comandos">
<span class="saida">sudo apt install timgm6mb-soundfont</span>
</pre>

 </li>
 </ol>

<section>
<h2>Referências</h2>

 <ul>
 <li><a href="http://imaginarycloud.com/blog/podman-vs-docker">http://imaginarycloud.com/blog/podman-vs-docker</a>
 </li>
 <li><a href="http://doomworld.com/classicdoom/info/shareware.php">http://doomworld.com/classicdoom/info/shareware.php</a>
 </li>
 </ul>

</section>
</section>
</div>
</body></html>
